// Auto-generated. Do not edit!

// (in-package rc_pick_client.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Box = require('./Box.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class Compartment {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose = null;
      this.box = null;
    }
    else {
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('box')) {
        this.box = initObj.box
      }
      else {
        this.box = new Box();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Compartment
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [box]
    bufferOffset = Box.serialize(obj.box, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Compartment
    let len;
    let data = new Compartment(null);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [box]
    data.box = Box.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 80;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_pick_client/Compartment';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '2bd962ccfb15f4a59dc58a77bede33e2';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Definition of a compartment (Primitive type without pose_frame and type)
    # type is implicit since currently only Box type is supported
    # the pose is relative to the pose_frame of the object including the compartment
    
    # Required
    # string type
    
    # Supported types
    # All primitives are defined to have their bounding boxes centered around (0,0,0)
    string BOX=BOX
    # string SPHERE=SPHERE
    # string CYLINDER=CYLINDER
    # string CONE=CONE
    
    # Optional: if not specified, the pose is relative to the pose_frame of the object including the primitive
    # string pose_frame
    
    # Optional: identity transformation assumed if not provided
    geometry_msgs/Pose pose
    
    # Only one of those required depending on the selected type
    Box box
    # Sphere sphere
    # Cylinder cylinder
    # Cone cone
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: rc_pick_client/Box
    # Definition of a box
    
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Compartment(null);
    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.Pose.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.Pose()
    }

    if (msg.box !== undefined) {
      resolved.box = Box.Resolve(msg.box)
    }
    else {
      resolved.box = new Box()
    }

    return resolved;
    }
};

// Constants for message
Compartment.Constants = {
  BOX: 'BOX',
}

module.exports = Compartment;
